'use strict';

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _generate = require('../flow/generate.js');

var _generate2 = _interopRequireDefault(_generate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MODELS = {
  Account: 'account',
  BalanceTransaction: 'balance_transaction',
  Card: 'card',
  Charge: 'charge',
  Coupon: 'coupon',
  Customer: 'customer',
  Discount: 'discount',
  Dispute: 'dispute'
};

describe('Stripe openapi', function () {
  // $FlowFixMe
  var spec = require(_path2.default.join(__dirname, '../../', 'openapi/openapi/spec2.json'));
  it('generates flow types for the entire spec', function () {
    expect((0, _generate2.default)(spec, _lodash2.default.mapValues(MODELS, function (key) {
      return spec.definitions[key];
    }))).toMatchSnapshot();
  });
});