'use strict';

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _generate = require('../js/generate.js');

var _generate2 = _interopRequireDefault(_generate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MODELS_TO_SNAPSHOT = ['account', 'balance_transaction', 'card', 'charge', 'coupon', 'customer', 'discount', 'dispute'];

describe('Stripe openapi', function () {
  // $FlowFixMe
  var spec = require(_path2.default.join(__dirname, '../../', 'openapi/openapi/spec2.json'));
  it('generates a validator for the entire spec', function () {
    var definitions = _lodash2.default.pick(spec.definitions, MODELS_TO_SNAPSHOT);
    var code = (0, _generate2.default)(spec, definitions);
    expect(code).toMatchSnapshot();

    var validators = eval('(function(){' + code + '})()'); // eslint-disable-line no-eval
    MODELS_TO_SNAPSHOT.forEach(function (property) {
      expect(validators).toHaveProperty(property);
    });
  });
});