'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _makeAst = require('./make-ast.js');

var _makeAst2 = _interopRequireDefault(_makeAst);

var _render = require('./render.js');

var _render2 = _interopRequireDefault(_render);

var _jsonPointer = require('json-pointer');

var _jsonPointer2 = _interopRequireDefault(_jsonPointer);

var _ast = require('./ast/ast.js');

var _ast2 = _interopRequireDefault(_ast);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Accepts the same arguments as js/generate
var generate = function generate(schema) {
  var shape = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { root: schema };

  var refResolver = function refResolver(ref) {
    if (ref.startsWith('#')) {
      var subSchema = _jsonPointer2.default.get(schema, decodeURIComponent(ref.substring(1)));
      return _lodash2.default.find(Object.keys(shape), function (key) {
        return shape[key] === subSchema;
      });
    } else {
      return null;
    }
  };

  return _lodash2.default.map(shape, function (subSchema, name) {
    var ast = (0, _makeAst2.default)(subSchema, refResolver);
    return (0, _render2.default)(_ast2.default.Declaration(name, ast));
  }).join('\n');
};
exports.default = generate;