'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _ast = require('../jsast/ast.js');

var _ast2 = _interopRequireDefault(_ast);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var allOf = function allOf(schema, symbol, context) {
  if (schema.allOf) {
    var nodes = _lodash2.default.flatMap(schema.allOf, function (subSchema) {
      var fnSym = context.symbolForSchema(subSchema);
      var result = context.gensym();
      return _ast2.default.Body(_ast2.default.Assignment(result, _ast2.default.Call(fnSym, symbol)), _ast2.default.If(_ast2.default.Binop.Neq(result, 'null'), context.error()));
    });
    return _ast2.default.Body.apply(_ast2.default, _toConsumableArray(nodes));
  } else {
    return _ast2.default.Empty;
  }
};

exports.default = allOf;