'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _util = require('../../util.js');

var _util2 = _interopRequireDefault(_util);

var _ast = require('../jsast/ast.js');

var _ast2 = _interopRequireDefault(_ast);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var items = function items(schema, symbol, context) {
  if (Array.isArray(schema.items)) {
    // Tuple. Handle each item individually.
    var checks = _lodash2.default.map(schema.items, function (subSchema, i) {
      var fnSym = context.symbolForSchema(subSchema);
      return _ast2.default.If(_ast2.default.Binop.And(_ast2.default.Binop.Lt('' + i, symbol + '.length'), _ast2.default.Binop.Neq(_ast2.default.Call(fnSym, symbol + '[' + i + ']'), 'null')), context.error());
    });
    return _ast2.default.Body.apply(_ast2.default, _toConsumableArray(checks));
  } else if (schema.items) {
    var fnSym = context.symbolForSchema(schema.items);
    var counter = context.gensym();
    var result = context.gensym();
    var check = _ast2.default.Body(_ast2.default.Assignment(counter, _ast2.default.Literal('0')), _ast2.default.Assignment(result, _ast2.default.Literal('null')), _ast2.default.For(_ast2.default.Empty, _ast2.default.Binop.Lt(counter, symbol + '.length'), _ast2.default.Literal(counter + '++'), _ast2.default.Body(_ast2.default.Assignment(result, _ast2.default.Call(fnSym, symbol + '[' + counter + ']')), _ast2.default.If(_ast2.default.Binop.Neq(result, 'null'), _ast2.default.Return(result)))));
    return _util2.default.typeCheck('array', symbol, check);
  } else {
    return _ast2.default.Empty;
  }
};

exports.default = items;