'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _util = require('../../util.js');

var _util2 = _interopRequireDefault(_util);

var _ast = require('../jsast/ast.js');

var _ast2 = _interopRequireDefault(_ast);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var predicate = function predicate(type, symbol, context) {
  if (typeof type === 'string') {
    // $FlowFixMe Wait until we can refine string -> enum
    return _util2.default.primitivePredicate(type, symbol);
  } else {
    var fnSym = context.symbolForSchema(type);
    return _ast2.default.Binop.Eq(_ast2.default.Call(fnSym, symbol), 'null');
  }
};

var type = function type(schema, symbol, context) {
  if (typeof schema.type === 'string') {
    return _ast2.default.If(_ast2.default.Not(_util2.default.primitivePredicate(schema.type, symbol)), context.error());
  } else if (Array.isArray(schema.type)) {
    if (schema.type.length === 1) {
      return _ast2.default.If(_ast2.default.Not(predicate(schema.type[0], symbol, context)), context.error());
    } else if (schema.type.length > 1) {
      // var count = 0;
      //
      // if (check1(data) === null) { count++ }
      // if (check2(data) === null) { count++ }
      //
      // if (count !== 1) { (error) }
      var count = context.gensym();
      var checks = _lodash2.default.map(schema.type, function (typeOrSubSchema) {
        return _ast2.default.If(_ast2.default.Not(predicate(typeOrSubSchema, symbol, context)), count + '++;');
      });
      return _ast2.default.Body(_ast2.default.Assignment(count, _ast2.default.Literal('0')), _ast2.default.Body.apply(_ast2.default, _toConsumableArray(checks)), _ast2.default.If(_ast2.default.Binop.Eq(count, '' + schema.type.length), context.error()));
    } else {
      return _ast2.default.Empty;
    }
  } else {
    return _ast2.default.Empty;
  }
};

exports.default = type;