'use strict';

var _uniqFuncs = require('../uniq-funcs.js');

var _uniqFuncs2 = _interopRequireDefault(_uniqFuncs);

var _ast = require('../ast.js');

var _ast2 = _interopRequireDefault(_ast);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('uniqFuncs', function () {
  it('handles functions with trivial bodies', function () {
    var ast = _ast2.default.Body(_ast2.default.Function1('f0', 'v', _ast2.default.Empty), _ast2.default.Function1('f1', 'v', _ast2.default.Return(_ast2.default.Call('f0', 'v'))));
    expect((0, _uniqFuncs2.default)(ast)).toEqual(_ast2.default.Body(_ast2.default.Function1('f0', 'v', _ast2.default.Empty), _ast2.default.Empty));
  });

  it('removes and renames duplicate functions', function () {
    var ast = _ast2.default.Body(_ast2.default.Function1('f0', 'v', _ast2.default.Return('null')), _ast2.default.Function1('f1', 'v', _ast2.default.Return('null')));
    expect((0, _uniqFuncs2.default)(ast)).toEqual(_ast2.default.Body(_ast2.default.Function1('f0', 'v', _ast2.default.Return('null')), _ast2.default.Empty));
  });
});