declare type Charge = {
  amount: number,
  amount_authorized: ?number,
  amount_captured: number,
  amount_refunded: number,
  application: ?string,
  application_fee: ?string,
  balance_transaction: ?string,
  captured: boolean,
  card: mixed,
  created: number,
  currency: string,
  customer: ?string,
  description: ?string,
  destination: ?string,
  dispute: ?string,
  failure_code: ?string,
  failure_message: ?string,
  fraud_details: ?{[key: string]: mixed},
  id: string,
  invoice: ?string,
  livemode: boolean,
  metadata: {[key: string]: mixed},
  object: string,
  on_behalf_of: ?string,
  order: ?string,
  outcome: mixed,
  paid: boolean,
  receipt_email: ?string,
  receipt_number: ?string,
  refunded: boolean,
  refunds: {
    data: Array<mixed>,
    has_more: boolean,
    object: "list",
    total_count: ?number,
    url: string,
  },
  review: ?string,
  shipping: mixed,
  source_transfer: ?string,
  statement_descriptor: ?string,
  status: string,
  transfer: ?string,
  transfer_group: ?string,
};
declare type Customer = {
  account_balance: number,
  alipay_accounts: ?{
    data: Array<mixed>,
    has_more: boolean,
    object: "list",
    total_count: ?number,
    url: string,
  },
  bank_accounts: ?{
    data: Array<mixed>,
    has_more: boolean,
    object: "list",
    total_count: ?number,
    url: string,
  },
  business_vat_id: ?string,
  cards: {
    data: Array<mixed>,
    has_more: boolean,
    object: "list",
    total_count: ?number,
    url: string,
  },
  created: number,
  currency: ?string,
  default_bank_account: ?string,
  default_card: ?string,
  default_source: ?string,
  delinquent: ?boolean,
  description: ?string,
  discount: mixed,
  email: ?string,
  id: string,
  livemode: boolean,
  metadata: {[key: string]: mixed},
  object: string,
  shipping: mixed,
  sources: {
    data: Array<{[key: string]: mixed}>,
    has_more: boolean,
    object: "list",
    total_count: ?number,
    url: string,
  },
  subscriptions: {
    data: Array<mixed>,
    has_more: boolean,
    object: "list",
    total_count: ?number,
    url: string,
  },
};